if(isFile("config/server/spawnCam.cs"))
exec("config/server/spawnCam.cs");

$Swol::DefaultSpawnCam = "-63.6339 77.9919 22.4103 0.0843708 -0.217854 0.972328 2.42131";

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
	{
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	}
	RTB_registerPref("Message","Spawn Cam","$Swol::SpawnCamMsg","string 255","Server_SpawnCam","<font:impact:75>Welcome!",0,0);
	RTB_registerPref("Time MS", "Spawn Cam", "$Swol::SpawnCamTime", "num 1000 10000", "Server_SpawnCam", 5000, 0, 0);
}
else
{
	$Swol::SpawnCamMsg = "<font:impact:75>Welcome!";
}
package Swol_SpawnCam
{
	function GameConnection::CreatePlayer(%cl,%pos)
	{
		%isHost = (%cl.isLocalConnection() || ($Server::LAN && $Server::Dedicated) || %cl.getBLID() $= getNumKeyID());
		if(!%cl.hasSpawnedBeforeCam && !%isHost)
		{
			schedule(50,0,swol_SpawnCam,%cl,%pos);
			%pos = "0 999999 999999";
		}
		parent::CreatePlayer(%cl,%pos);
	}
	function swol_SpawnCam(%cl,%spPos)
	{
		if(!strLen($Swol::SpawnCamPos))
		%pos = $Swol::DefaultSpawnCam;
		else
		%pos = $Swol::SpawnCamPos;
		
		%cam = %cl.camera;
		%pl = %cl.player;
		
		if(%cl.isOrbing)
		serverCmdDropPlayerAtCamera(%cl);
		
		%cl.inSpawnCam = 1;
		
		%cam.setTransform(%pos);
		%cl.setControlObject(%cam);
		%cam.setControlObject(%pl);
		%pl.setTransform("0 999999 999999");
		centerPrint(%cl,$Swol::SpawnCamMsg,mFloor($Swol::SpawnCamTime/1000));
		%cl.camSched = schedule($Swol::SpawnCamTime,0,swol_ResetSpawnCam,%cl,%spPos);
	}
	function swol_ResetSpawnCam(%cl,%spPos)
	{
		cancel(%cl.camSched);
		%cam = %cl.camera;
		%pl = %cl.player;
		
		%cl.inSpawnCam = 0;
		%cl.setControlObject(%pl);
		%cam.setControlObject(%cam);
		%cl.hasSpawnedBeforeCam = 1;
		%pl.setTransform(%spPos);
	}
	function serverCmdSetSpawnCam(%cl)
	{
		if(!%cl.isSuperAdmin)
		return;
		
		if(getSimTime()-$Swol::LastSpawnCamSetTime < 7500)
		return;
		
		if(!%cl.isOrbing)
		return MessageClient(%cl,'',"\c6Please go into orb mode before setting the spawn cam");
		
		$Swol::LastSpawnCamSetTime = getSimTime();
		
		$Swol::SpawnCamPos = %cl.camera.getTransform();
		export("$Swol::SpawnCamPos","config/server/spawnCam.cs");
		MessageAll('',"\c3" @ %cl.name @ "\c2 changed the spawn cam location");
	}
	function serverCmdTestSpawnCam(%cl)
	{
		if(!isObject(%cl.player))
		return;
		
		if(!%cl.isSuperAdmin)
		return;
		
		%pl = %cl.player;
		
		swol_SpawnCam(%cl,%pl.getTransform());
	}
	function serverCmdUseTool(%client,%slot)
	{
		%player = %client.player;
		if(!isObject(%player))
		return parent::serverCmdUseTool(%client,%slot);
		
		if(%client.inSpawnCam)
		return;
		
		parent::serverCmdUseTool(%client,%slot);
	}
	function serverCmdUseInventory(%client,%num)
	{
		%player = %client.player;
		if(!isObject(%player))
		return parent::serverCmdUseInventory(%client,%num);
		
		if(%client.inSpawnCam)
		return;
		
		parent::serverCmdUseInventory(%client,%num);
	}
	function GameConnection::setControlObject(%cl,%obj)
	{
		if(!isObject(%cl.player))
		return parent::setControlObject(%pl,%obj);
		
		%pl = %cl.player;
		if(isObject(%pl.client))
		{
			if(%obj == %pl.client.camera)
			{
				%pl.client.isOrbing = 1;
			}
			if(%obj == %pl)
			{
				%pl.client.isOrbing = 0;
			}
		}
		parent::setControlObject(%pl,%obj);
	}
	//Fixes for another addon
	function gameConnection::fallLoop(%this)
	{
		if(!%this.hasSpawnedBeforeCam)
		return;
		
		parent::fallLoop(%this);
	}
};
ActivatePackage(Swol_SpawnCam);